## caveexpress 2.5.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(caveproductions)

#-------------------------------------------------------------------------------
# options
#-------------------------------------------------------------------------------

option(NETWORKING "Enable networking" ON)
option(UNITTESTS "Builds with unittests" ON)
option(TOOLS "Builds with tools" ON)
option(VERBOSE "Print debug information" OFF)
option(COVERAGE "Compile with test coverage" OFF)
option(USE_CCACHE "Use ccache" ON)
# The build system will search for system libs, if it can't find them (e.g. via pkg-config)
# it will take those that are bundled under src/libs. If you don't want that for some reason,
# you can set this to ON and the libs dir will not be taken into account at all.
option(FORCE_USE_SYSTEM_LIBS "Use system libs" OFF)
option(CAVEEXPRESS "Build caveexpress" ON)
option(CAVEPACKER "Build cavepacker" ON)
option(SANITIZER "Build with sanitizer support if available" OFF)
option(ANDROID_INSTALL_PACKAGES "Install required android packages" ON)

#-------------------------------------------------------------------------------
# end options
#-------------------------------------------------------------------------------

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Compile Type" FORCE)
endif()
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo)

if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
	set(RELEASE False)
else()
	set(RELEASE True)
endif()

if (BUILD_SHARED_LIBS)
	message(STATUS "Forcing building the internal libraries as static, even though BUILD_SHARED_LIBS=ON was requested.")
	set(BUILD_SHARED_LIBS OFF)
endif()

set(ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE STRING "Root dir")
message(STATUS "Place binaries in ${ROOT_DIR}")
# First for the generic no-config case (e.g. with mingw)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ROOT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)

# Second, for multi-config builds (e.g. msvc)
foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
	string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${ROOT_DIR})
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/lib)
endforeach()
set(DEFAULT_LUAC_EXECUTABLE luac)
set(CP_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CP_CMAKE_DIR})
set(CMAKE_VERBOSE_MAKEFILE ${VERBOSE})
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_CXX_EXTENSIONS off)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if (${CMAKE_EXTRA_GENERATOR} MATCHES "Eclipse CDT4")
	message(STATUS "Generate eclipse projects")
	set(CMAKE_ECLIPSE_GENERATE_LINKED_RESOURCES OFF)
	set(CMAKE_ECLIPSE_GENERATE_SOURCE_PROJECT ON)
	set(CMAKE_ECLIPSE_VERSION "4.3" CACHE STRING "Eclipse version")
	set(CMAKE_CXX_COMPILER_ARG1 "-std=c++11" CACHE STRING "C++ version for Eclipse")
endif()

find_program(GDB_EXECUTABLE gdb)
find_program(LLDB_EXECUTABLE lldb)
if (GDB_EXECUTABLE)
	set(DEBUGGER ${GDB_EXECUTABLE} CACHE STRING "Which debugger should be used")
elseif (LLDB_EXECUTABLE)
	set(DEBUGGER ${LLDB_EXECUTABLE} CACHE STRING "Which debugger should be used")
else()
	set(DEBUGGER "unknown" CACHE STRING "Which debugger should be used")
	message(STATUS "No debugger (gdb or lldb) was found")
endif()
set_property(CACHE DEBUGGER PROPERTY STRINGS gdb lldb)

include(${CP_CMAKE_DIR}/macros.cmake)

if (COVERAGE)
	if ((CP_GCC OR CP_CLANG) AND NOT RELEASE)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
	elseif (RELEASE)
		message(WARNING "Skip coverage, you attempt to compile in release mode")
	else()
		message(WARNING "Skip coverage, you don't compile with gcc or clang")
	endif()
endif()

cp_message("ROOT_DIR: ${ROOT_DIR}")
cp_message("CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")
cp_message("PROJECT_SOURCE_DIR: ${PROJECT_SOURCE_DIR}")
message(STATUS "CMAKE_SYSTEM_NAME: ${CMAKE_SYSTEM_NAME}")
message(STATUS "CMAKE_HOST_SYSTEM_NAME: ${CMAKE_HOST_SYSTEM_NAME}")

#-------------------------------------------------------------------------------
# variables
#-------------------------------------------------------------------------------

if (WIN32)
	set(WINDOWS 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Android")
	set(LINUX 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
	set(DARWIN 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	set(LINUX 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten")
	set(EMSCRIPTEN 1)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Haiku")
	set(HAIKU 1)
else()
	message(WARNING "Unknown host system: ${CMAKE_SYSTEM_NAME}. Default to linux")
	set(LINUX 1)
endif()

include(${CP_CMAKE_DIR}/pack.cmake)
include(CPack)

# on mac it e.g. finds the gui launcher - this is not what we want - find a proper way to handle this
if (NOT ${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Darwin")
	find_host_program(TEXTUREPACKER_BIN NAMES TexturePacker)
	if (TEXTUREPACKER_BIN)
		execute_process(COMMAND ${TEXTUREPACKER_BIN} --format CaveExpress ERROR_VARIABLE TEXTURE_PACKER_EXPORTER)
		if (TEXTURE_PACKER_EXPORTER MATCHES "Unknown format")
			message(STATUS "Found TexturePacker: ${TEXTUREPACKER_BIN}")
			message(WARNING "but without the needed exporter. Find it in contrib/assets/png-packed/exporter. Check out the HOWTO.md in that directory.")
			unset(TEXTUREPACKER_BIN)
		else()
			message(STATUS "Found TexturePacker: ${TEXTUREPACKER_BIN}")
		endif()
	else()
		message(STATUS "Could not find TexturePacker")
	endif()
endif()
if (NOT CMAKE_TOOLCHAIN_FILE)
	if (WINDOWS)
		include(${CP_CMAKE_DIR}/toolchains/windows-toolchain.cmake)
	elseif (DARWIN)
		include(${CP_CMAKE_DIR}/toolchains/darwin-toolchain.cmake)
	elseif (HAIKU)
		include(${CP_CMAKE_DIR}/toolchains/haiku-toolchain.cmake)
	else()
		include(${CP_CMAKE_DIR}/toolchains/linux-toolchain.cmake)
	endif()
else()
	if (MSVC)
		# 4456: declaration of 'q' hides previous local declaration
		# 4244: possible loss of data (e.g. float/double)
		# 4201: nonstandard extension used
		# 4245: signed/unsigned mismatch
		# 4100: unreferenced formal parameter
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4244 /wd4245 /wd4201 /wd4100 /wd4456 /wd4267")
	endif()
endif()
set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")

if (ANDROID)
	include(${CP_CMAKE_DIR}/android.cmake)
elseif (IOS)
	include(${CP_CMAKE_DIR}/ios.cmake)
elseif (DARWIN)
	include(${CP_CMAKE_DIR}/darwin.cmake)
elseif (WINDOWS)
#	include(${CP_CMAKE_DIR}/windows.cmake)
elseif (NACL)
	include(${CP_CMAKE_DIR}/nacl.cmake)
elseif (EMSCRIPTEN)
	include(${CP_CMAKE_DIR}/emscripten.cmake)
elseif (HAIKU)
#	include(${CP_CMAKE_DIR}/haiku.cmake)
endif()

if (PKGDATADIR)
	add_definitions(-DPKGDATADIR="${PKGDATADIR}")
	message(STATUS "You specified a package data dir - the game will append the game name to this directory.")
	message(STATUS "So you get e.g. ${PKGDATADIR}/caveexpress as final directory.")
endif()

if (NOT NETWORKING)
	add_definitions(-DNONETWORK=1)
endif()

if (NOT CMAKE_BUILD_TYPE)
	if (RELEASE)
		set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Compile Type" FORCE)
	else()
		set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Compile Type" FORCE)
	endif()
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release)
endif()

find_host_program(CCACHE "ccache")
if (CCACHE)
	if (USE_CCACHE)
		message(STATUS "Using ccache")
		set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE})
		set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE})
	endif()
else()
	message(STATUS "ccache not found")
endif()

find_package(sdl2 REQUIRED)
find_package(SDL2_mixer REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_net REQUIRED)
find_package(sqlite3 REQUIRED)
find_package(lua REQUIRED)
find_package(box2d REQUIRED)
find_package(zlib REQUIRED)

configure_file(${ROOT_DIR}/src/config.h.in ${CMAKE_BINARY_DIR}/cp-config.h)
include_directories(${CMAKE_BINARY_DIR})

add_subdirectory(src/libs)

include_directories(src)
include_directories(src/modules)
include_directories(BEFORE src/modules/physics)
if (UNITTESTS)
	include_directories(src/libs/gtest)
	include_directories(src/libs/gtest/include)
endif()

# TODO move into lib cmakefiles
if (LUA_FOUND)
	add_definitions(-DHAVE_LUA_H)
endif()
if (UNITTESTS)
	enable_testing()
endif()
add_subdirectory(src/modules)
if (CAVEPACKER)
	add_subdirectory(src/cavepacker)
endif()
if (CAVEEXPRESS)
	add_subdirectory(src/caveexpress)
endif()
if (UNITTESTS)
	add_subdirectory(src/tests)
endif()

=== Makefile ===
# Allow to override settings
CONFIG         ?= Makefile.local
-include $(CONFIG)

Q              ?= @
UPDATEDIR      := /tmp
BUILDTYPE      ?= Debug
BUILDDIR       ?= ./build/$(BUILDTYPE)
INSTALL_DIR    ?= $(BUILDDIR)
GENERATOR      := Ninja
CMAKE          ?= cmake
CMAKE_OPTIONS  ?= -DFORCE_USE_SYSTEM_LIBS=1 -DCMAKE_BUILD_TYPE=$(BUILDTYPE) -G$(GENERATOR) --graphviz=$(BUILDDIR)/deps.dot

all:
	$(Q)if [ ! -f $(BUILDDIR)/CMakeCache.txt ]; then $(CMAKE) -H$(CURDIR) -B$(BUILDDIR) $(CMAKE_OPTIONS); fi
	$(Q)$(CMAKE) --build $(BUILDDIR) --target $@
	$(Q)$(CMAKE) -E create_symlink build/Debug/compile_commands.json compile_commands.json

release:
	$(Q)$(MAKE) BUILDTYPE=Release

clean:
	$(Q)rm -rf $(BUILDDIR)

distclean:
	$(Q)git clean -fdx

ccmake:
	$(Q)ccmake -B$(BUILDDIR) -S.

release-%:
	$(Q)$(MAKE) BUILDTYPE=Release $(subst release-,,$@)

%:
	$(Q)if [ ! -f $(BUILDDIR)/CMakeCache.txt ]; then $(CMAKE) -H$(CURDIR) -B$(BUILDDIR) $(CMAKE_OPTIONS); fi
	$(Q)$(CMAKE) --build $(BUILDDIR) --target $@
	$(Q)$(CMAKE) --install $(BUILDDIR) --component $@ --prefix $(INSTALL_DIR)/install-$@
	$(Q)$(CMAKE) -E create_symlink build/Debug/compile_commands.json compile_commands.json

dependency-%:
	$(Q)$(CMAKE) -H$(CURDIR) -B$(BUILDDIR) $(CMAKE_OPTIONS)
	$(Q)dot -Tsvg $(BUILDDIR)/deps.dot.$(subst dependency-,,$@) -o $(BUILDDIR)/deps.dot.$(subst dependency-,,$@).svg;
	$(Q)xdg-open $(BUILDDIR)/deps.dot.$(subst dependency-,,$@).svg;

=== src/caveexpress/main/CMakeLists.txt ===
project(caveexpress)
set(TPS
	caveexpress-entity
	caveexpress-environment-ice
	caveexpress-environment
	caveexpress-npc_blowing
	caveexpress-npc_fish
	caveexpress-npc_flying
	caveexpress-npc_grandpa
	caveexpress-npc_mammut
	caveexpress-npc_man
	caveexpress-npc_walking
	caveexpress-npc_woman
	caveexpress-packagetarget-ice
	caveexpress-packagetarget-rock
	caveexpress-ui-dead
	caveexpress-ui-fonts
	caveexpress-ui-npc-mammut
	caveexpress-ui-player-grandpa
	caveexpress-ui-scene
	caveexpress-ui
)
cp_add_executable(TARGET ${PROJECT_NAME} TPS ${TPS} SRCS CaveExpress.cpp ../../Main.cpp WINDOWED APPNAME "CaveExpress" VERSION 2.5 VERSION_CODE 31 CATEGORY ActionGame)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${PROJECT_NAME}-server ${PROJECT_NAME}-client ${PROJECT_NAME}-shared game)
set(LUAFILES config.lua entities.lua entitysounds.lua fonts.lua sprites.lua textures/complete.lua)
check_lua_files(${PROJECT_NAME} "${LUAFILES}")

=== src/caveexpress/server/CMakeLists.txt ===
set(caveexpress-server_SRCS
	map/RandomMapContext.cpp
	map/Map.cpp
	events/GameEventHandler.cpp
	entities/CollectableEntity.cpp
	entities/Stone.cpp
	entities/Platform.cpp
	entities/npcs/INPCCave.cpp
	entities/npcs/NPCBlowing.cpp
	entities/npcs/NPC.cpp
	entities/npcs/NPCAttacking.cpp
	entities/npcs/NPCPackage.cpp
	entities/npcs/NPCFish.cpp
	entities/npcs/NPCFlying.cpp
	entities/npcs/NPCFriendly.cpp
	entities/npcs/NPCAggressive.cpp
	entities/Package.cpp
	entities/Egg.cpp
	entities/MapTile.cpp
	entities/WorldParticle.cpp
	entities/modificators/WindModificator.cpp
	entities/EntityEmitter.cpp
	entities/Tree.cpp
	entities/IEntity.cpp
	entities/Geyser.cpp
	entities/Water.cpp
	entities/PackageTarget.cpp
	entities/CaveMapTile.cpp
	entities/Bomb.cpp
	entities/Player.cpp
	entities/Border.cpp
	entities/Fruit.cpp
	entities/WindowTile.cpp
)
add_library(caveexpress-server ${caveexpress-server_SRCS})
set_target_properties(caveexpress-server PROPERTIES FOLDER caveexpress-server)
cp_target_link_libraries(TARGET caveexpress-server LIBS mainloop physics caveexpress-shared)

=== src/caveexpress/shared/CMakeLists.txt ===
set(caveexpress-shared_SRCS
	CaveExpressAchievement.cpp
	CaveExpressSoundType.cpp
	CaveExpressCooldown.cpp
	CaveExpressAnimation.cpp
	CaveExpressSpriteType.cpp
	CaveExpressEntityType.cpp
	CaveExpressMapFailedReasons.cpp
)
add_library(caveexpress-shared ${caveexpress-shared_SRCS})
set_target_properties(caveexpress-shared PROPERTIES FOLDER caveexpress-shared)
cp_target_link_libraries(TARGET caveexpress-shared LIBS common network)

=== src/caveexpress/tests/CMakeLists.txt ===
set(NAME caveexpress)
project(tests_${NAME})
SET(${PROJECT_NAME}_SRC
	ProtocolTest.cpp
	EnumSpriteTypesTest.cpp
	LUASpriteTest.cpp
	RandomMapContextTest.cpp
	MapTest.cpp
	MapManagerTest.cpp
	CampaignTest.cpp
	../main/CaveExpress.cpp
	../../tests/TestAll.cpp
	../../tests/TestShared.cpp
	../../tests/NetworkTest.cpp
	../../tests/NoNetworkTest.cpp
)
cp_add_executable(TARGET ${PROJECT_NAME} SRCS ${${PROJECT_NAME}_SRC} APPNAME ${PROJECT_NAME} VERSION 1.0 VERSION_CODE 1)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${NAME}-client ${NAME}-server ${NAME}-shared gtest)
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== src/cavepacker/main/CMakeLists.txt ===
project(cavepacker)
set(TPS
	cavepacker-entity
	cavepacker-environment
	cavepacker-ui-fonts
	cavepacker-ui-scene
	cavepacker-ui
)
cp_add_executable(TARGET ${PROJECT_NAME} TPS ${TPS} SRCS CavePacker.cpp ../../Main.cpp WINDOWED APPNAME "CavePacker" VERSION 1.5 VERSION_CODE 11 CATEGORY LogicGame)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${PROJECT_NAME}-server ${PROJECT_NAME}-client ${PROJECT_NAME}-shared game)
set(LUAFILES config.lua fonts.lua sprites.lua textures/complete.lua)
check_lua_files(${PROJECT_NAME} "${LUAFILES}")

=== src/cavepacker/tests/CMakeLists.txt ===
set(NAME cavepacker)
project(tests_${NAME})
SET(${PROJECT_NAME}_SRC
	BoardStateTest.cpp
	MapManagerTest.cpp
	ProtocolTest.cpp
	SokobanMapContextTest.cpp
	SokobanMapTest.cpp
	CampaignTest.cpp
	PathfindingTest.cpp
	SolutionUtilTest.cpp
	../main/CavePacker.cpp
	../../tests/TestAll.cpp
	../../tests/TestShared.cpp
	../../tests/NetworkTest.cpp
	../../tests/NoNetworkTest.cpp
)
cp_add_executable(TARGET ${PROJECT_NAME} SRCS ${${PROJECT_NAME}_SRC} APPNAME ${PROJECT_NAME} VERSION 1.0 VERSION_CODE 1)
cp_target_link_libraries(TARGET ${PROJECT_NAME} LIBS ${NAME}-client ${NAME}-server ${NAME}-shared gtest)
if (MSVC)
	target_compile_options(${PROJECT_NAME} PRIVATE -bigobj)
endif()
add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== src/modules/campaign/CMakeLists.txt ===
set(campaign_SRCS
	CampaignMap.cpp
	CampaignManager.cpp
	persister/SQLitePersister.cpp
	persister/GooglePlayPersister.cpp
	Campaign.cpp
)

add_library(campaign ${campaign_SRCS})
set_target_properties(campaign PROPERTIES FOLDER campaign)
cp_target_link_libraries(TARGET campaign LIBS common)

=== src/modules/common/CMakeLists.txt ===
set(common_SRCS
	ConfigPersisterSQL.cpp
	ThemeType.cpp
	KeyValueParser.cpp
	TextureDefinition.cpp
	IConsole.cpp
	String.cpp
	SQLite.cpp
	Thread.cpp
	ConfigManager.cpp
	EventHandler.cpp
	MemoryAllocator.cpp
	TextConsole.cpp
	MapManager.cpp
	FileSystem.cpp
	LUALibrary.cpp
	LUAMapContext.cpp
	Log.cpp
	TimeManager.cpp
	ExecutionTime.cpp
	File.cpp
	ConsoleFrontend.cpp
	ConfigVar.cpp
	CommandSystem.cpp
	SpriteDefinition.cpp
	URI.cpp
	ByteStream.cpp
)

set(LIBS lua sdl2 sqlite3 box2d glm)
if(WINDOWS)
	set(ports_SRCS ports/Windows.cpp)
elseif(ANDROID)
	set(ports_SRCS ports/Unix.cpp ports/Android.cpp)
elseif(NACL)
	set(ports_SRCS ports/NaCl.cpp)
elseif(IOS)
	set(ports_SRCS ports/Unix.cpp ports/IOS.cpp ports/IOSObjc.mm)
elseif(DARWIN)
	set(ports_SRCS ports/Unix.cpp ports/Darwin.cpp ports/DarwinObjc.mm)
	list(APPEND LIBS "-framework CoreServices" "-framework Foundation" "-framework CoreFoundation")
elseif(EMSCRIPTEN)
	set(ports_SRCS ports/Unix.cpp ports/HTML5.cpp)
elseif(UNIX)
	set(ports_SRCS ports/Unix.cpp)
	add_definitions(-D_GNU_SOURCE -D_DEFAULT_SOURCE -D_XOPEN_SOURCE)
endif()

if (CURSES_FOUND)
	list(APPEND LIBS ${CURSES_LIBRARIES})
endif()

add_library(common ${common_SRCS} ${ports_SRCS})
set_target_properties(common PROPERTIES FOLDER common)
cp_target_link_libraries(TARGET common LIBS ${LIBS})

=== src/modules/gfx/CMakeLists.txt ===
set(gfx_SRCS
	AbstractGLFrontend.cpp
	SDLFrontend.cpp
	GL3Frontend.cpp
	GLFunc.cpp
	FrameBuffer.cpp
	Shader.cpp
)
if (NOT ANDROID)
list(APPEND gfx_SRCS
	GL1Frontend.cpp
)
endif()
add_library(gfx ${gfx_SRCS})
set_target_properties(gfx PROPERTIES FOLDER gfx)
set(DEPS common texture ui)
if (ANDROID)
	list(APPEND DEPS GLESv1_CM GLESv2)
endif()
cp_target_link_libraries(TARGET gfx LIBS ${DEPS})

=== src/modules/particles/CMakeLists.txt ===
set(particle_SRCS Bubble.cpp Particle.cpp ParticleSystem.cpp Snow.cpp Sparkle.cpp)
add_library(particle ${particle_SRCS})
set_target_properties(particle PROPERTIES FOLDER particle)
cp_target_link_libraries(TARGET particle LIBS common texture)

=== debian/changelog ===
caveexpress (2.5.2-4) unstable; urgency=medium

  * Team Upload
  * reformat d/control with debputy

  [ Patrice Duroux ]
  * d/patches: use SDL_mixer.h in the right place (Closes: #1095714)
  * d/salsa-ci.yml: added to use Salsa CI.
  * d/rules: force LC_ALL to satisfy reprotest.
  * d/salsaci.yml: activate diffoscope for reprotest
  * d/salsa-ci.yml: update (noeol).

 -- Alexandre Detiste <tchet@debian.org>  Fri, 07 Mar 2025 15:33:34 +0100

caveexpress (2.5.2-3) unstable; urgency=medium

  * Team upload.
  * Set Rules-Requires-Root: no
  * Replace obsolete pkg-config with pkgconf
  * Replace obsolete libncurses5-dev with libncurses-dev

 -- Alexandre Detiste <tchet@debian.org>  Sat, 23 Nov 2024 14:37:13 +0100

caveexpress (2.5.2-2) unstable; urgency=medium

  * Team upload.
  * Drop lua5.2 from Build-Depends.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Bastian Germann <bage@debian.org>  Fri, 25 Aug 2023 20:01:05 +0200

caveexpress (2.5.2-1) unstable; urgency=medium

  * New upstream version 2.5.2.
  * Tighten build-dependency on libbox2d-dev. (Closes: #993710)
  * Declare compliance with Debian Policy 4.6.0.
  * Mark data packages as Multi-Arch: foreign
  * d/rules: Remove miniracer option.
  * Build-depend on lua5.4.

 -- Markus Koschany <apo@debian.org>  Sun, 05 Sep 2021 16:07:02 +0200

=== debian/control ===
Source: caveexpress
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libbox2d-dev (>= 2.4.1),
 libglm-dev,
 libgtest-dev,
 liblua5.4-dev,
 libncurses-dev,
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-net-dev,
 libsqlite3-dev,
 libtinyxml2-dev,
 libyajl-dev,
 pkgconf,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: http://www.caveproductions.org
Vcs-Git: https://salsa.debian.org/games-team/caveexpress.git
Vcs-Browser: https://salsa.debian.org/games-team/caveexpress
X-Style: black

Package: caveexpress
Architecture: any
Depends:
 caveexpress-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: 2D platformer with physics-based gameplay
 CaveExpress is a classic 2D platformer with physics-based gameplay
 and dozens of levels. Master your pedal-powered flying machine to
 pick up packages from your cave-dwelling clients and drop them off
 at the collection point.
 .
 But beware! Mighty mastodons, terrifying pterodactyls and others
 would rather see you extinct.

Package: caveexpress-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Suggests:
 caveexpress,
Description: 2D platformer with physics-based gameplay --data
 CaveExpress is a classic 2D platformer with physics-based gameplay
 and dozens of levels. Master your pedal-powered flying machine to
 pick up packages from your cave-dwelling clients and drop them off
 at the collection point.
 .
 This package contains the data files needed to play CaveExpress.

Package: cavepacker
Architecture: any
Depends:
 cavepacker-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: sokoban game with network based multiplayer gaming
 CavePacker is a sokoban game. It is a puzzle game where you have to move the
 packages onto their targets without getting stuck. The lesser steps you made
 for solving a level, the better. You may only push but not pull packages.

Package: cavepacker-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Suggests:
 cavepacker,
Description: sokoban game with network based multiplayer gaming --data
 CavePacker is a sokoban game. It is a puzzle game where you have to move the
 packages onto their targets without getting stuck. The lesser steps you made
 for solving a level, the better. You may only push but not pull packages.
 .
 This package contains the data files needed to play CavePacker.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export CCACHE_DIR=$(CURDIR)/ccache

# force locale to satisfy reprotest due to config/scripts/lang.sh
export LC_ALL=C.UTF-8

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DNETWORKING=ON \
		-DUNITTESTS=OFF \
		-DTOOLS=OFF \
		-DVERBOSE=ON \
		-DCOVERAGE=OFF \
		-DUSE_CCACHE=ON \
		-DCAVEEXPRESS=ON \
		-DCAVEPACKER=ON \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DPKGDATADIR=/usr/share/games \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_CXX_FLAGS_RELEASE="-DNDEBUG"

override_dh_installchangelogs:
	dh_installchangelogs docs/caveexpress/CHANGELOG

override_dh_missing:
	dh_missing --list-missing

override_dh_auto_clean:
	rm -rf caveexpress cavepacker obj-*/ ccache*/ base/cave*/textures/complete.lua

override_dh_auto_test:

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/caveexpress-$1\.tar\.gz/ \
  https://github.com/mgerhardy/caveexpress/tags .*/v?(\d\S*)\.tar\.gz
